package edu.dhbw.pv;

public class Uebung4 {
    static double globaleSumme = 0.0;
    public static void main(String[] args) {
        int anzahl = 1000; 
        Semaphore sema = new Semaphore(1);
        Thread[] ths = new Thread[anzahl];
        long t = System.currentTimeMillis();
        for (int j = 0; j < anzahl; j++) {
            ths[j] = new Thread( new Summe4(j, sema) );
            ths[j].start();
        }
        for (int j = 0;j < anzahl; j++ ) {
            try {
                ths[j].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }   
        }
        System.out.println("globaleSumme  " + globaleSumme);
        t = System.currentTimeMillis() - t;
        System.out.println("time = " + t);
        System.exit(0);
    }

}
class Summe4 implements Runnable {
    int j = 0;
    Semaphore sema;
    public Summe4(int jj, Semaphore s) {
        j = jj;
        sema = s;
    }
    public void run() {
        System.out.println("Thread " + j);
        double sum = 0.0;
        for (int i = 0; i< 1000; i++) {
            sum += Math.cos(i+j);
        }
        //synchronized(Uebung4.class) { 
        try {
            sema.aquire();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Uebung4.globaleSumme += sum;
        sema.release();
        //}
        System.out.println("sum(" +j+ ") = " + sum);
    }
}

