package edu.dhbw.pv;

import java.util.concurrent.ThreadLocalRandom;
import java.util.stream.DoubleStream;

public class Uebung7 {
    public static void main(String[] args) {
        long anzahl = 1_000_000_000;
        long ts, tp;
        ts = System.currentTimeMillis();
        DoubleStream doubles = ThreadLocalRandom.current().doubles(anzahl);
        //double[] list = doubles.toArray();
        long imKreis = doubles.filter(x -> {
                           double y = ThreadLocalRandom.current().nextDouble();
                           return x*x + y*y <= 1.0;
        } )
                .count();
        ts = System.currentTimeMillis() - ts;
        double pi = (double)imKreis/(double)anzahl * 4.0;
        System.out.println("pi = " + pi);
        
        tp = System.currentTimeMillis();
        doubles = ThreadLocalRandom.current().doubles(anzahl).parallel();
        imKreis = doubles.filter(x -> {
                           double y = ThreadLocalRandom.current().nextDouble();
                           return x*x + y*y <= 1.0;
        } )
                .count();
        tp = System.currentTimeMillis()- tp;
        pi = (double)imKreis/(double)anzahl * 4.0;
        System.out.println("pi = " + pi);
        System.out.println("seqientiell " + ts);
        System.out.println("parallel    " + tp);
    }

}
